<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="公司名称" prop="compyId">
        <el-select v-model="queryParams.compyId" placeholder="请选择公司名称" @change="doCompyChange">
          <el-option v-for="it in compyOpts" :key="it.deptId" :label="it.deptName" :value="it.deptId" />
        </el-select>
      </el-form-item>

      <el-form-item label="项目名称" prop="defaultDeptId">
        <el-select v-model="queryParams.defaultDeptId" placeholder="请选择项目名称">
          <el-option v-for="it in prjOpts" :key="it.deptId" :label="it.deptName" :value="it.deptId" />
        </el-select>
      </el-form-item>

      <el-form-item label="资产类型" prop="type">
        <el-select v-model="queryParams.type" placeholder="请选择资产类型" clearable>
          <el-option v-for="dict in dict.type.sys_process_category" :key="dict.value" :label="dict.label"
            :value="dict.value" />
        </el-select>
      </el-form-item>
      <el-form-item label="资产名称" prop="name">
        <el-input v-model="queryParams.name" placeholder="请输入资产名称" clearable @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item label="资产单位" prop="unit">
        <el-input v-model="queryParams.unit" placeholder="请输入资产单位" clearable @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
          v-hasPermi="['base:assetsType:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="el-icon-edit" size="mini" :disabled="single" @click="handleUpdate"
          v-hasPermi="['base:assetsType:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="el-icon-delete" size="mini" :disabled="multiple" @click="handleDelete"
          v-hasPermi="['base:assetsType:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport"
          v-hasPermi="['base:assetsType:export']">导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="assetsTypeList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="主键" align="center" prop="id" width="55"/>
      <el-table-column label="资产类型" align="center" prop="type" width="120">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.sys_process_category" :value="scope.row.type" />
        </template>
      </el-table-column>
      <el-table-column label="资产名称" align="left" prop="name">
        <template slot-scope="scope">
          <el-tag v-if="!scope.row.deptId" effect="dark" type="danger">系统</el-tag>
          {{ scope.row.name }}
        </template>
      </el-table-column>
      <el-table-column label="资产单位" align="center" prop="unit" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" width="160">
        <template slot-scope="scope">
          <template v-if="scope.row.deptId">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
            v-hasPermi="['base:assetsType:edit']">修改</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
            v-hasPermi="['base:assetsType:remove']">删除</el-button>
          </template>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize"
      @pagination="getList" />

    <!-- 添加或修改物资类型对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="父级分类" prop="parentId">
          <el-input v-model="form.parentId" placeholder="请输入父级分类" />
        </el-form-item>
        <el-form-item label="单位主键" prop="deptId">
          <el-input v-model="form.deptId" placeholder="请输入单位主键" />
        </el-form-item>
        <el-form-item label="资产类型" prop="type">
          <el-select v-model="form.type" placeholder="请选择资产类型">
            <el-option v-for="dict in dict.type.sys_process_category" :key="dict.value" :label="dict.label"
              :value="dict.value"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="资产名称" prop="name">
          <el-input v-model="form.name" placeholder="请输入资产名称" />
        </el-form-item>
        <el-form-item label="资产单位" prop="unit">
          <el-input v-model="form.unit" placeholder="请输入资产单位" />
        </el-form-item>
        <el-form-item label="是否删除" prop="isDel">
          <el-select v-model="form.isDel" placeholder="请选择是否删除">
            <el-option v-for="dict in dict.type.sys_is_del" :key="dict.value" :label="dict.label"
              :value="dict.value"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listAssetsType, getAssetsType, delAssetsType, addAssetsType, updateAssetsType } from "@/api/base/assetsType";
import { listDept } from '@/api/system/dept'
export default {
  name: "AssetsType",
  dicts: ['sys_process_category', 'sys_is_del'],
  data() {
    return {
      depOpts: [],
      compyOpts: [],
      prjOpts: [],
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 物资类型表格数据
      assetsTypeList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        parentId: null,
        compyId: null,
        defaultDeptId: null,
        type: null,
        name: null,
        unit: null,
        isDel: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    listDept().then(d => {
      this.depOpts = d.data || [];
      this.compyOpts = this.depOpts.filter(it => it.parentId == 100)
      if (this.compyOpts.length > 0) {
        this.queryParams.compyId = this.compyOpts[0].deptId;
        this.prjOpts = this.depOpts.filter(it => it.parentId == this.queryParams.compyId);
        if (this.prjOpts.length > 0) {
          this.queryParams.defaultDeptId = this.prjOpts[0].deptId;
          this.getList();
        }
      }
    });

  },
  methods: {
    doCompyChange(a) {
      this.prjOpts = this.depOpts.filter(it => it.parentId == this.queryParams.compyId);
      if (this.prjOpts.length > 0) {
        this.queryParams.defaultDeptId = this.prjOpts[0].deptId;
      }
    },
    /** 查询物资类型列表 */
    getList() {
      this.loading = true;
      listAssetsType(this.queryParams).then(response => {
        this.assetsTypeList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        parentId: null,
        deptId: null,
        type: null,
        name: null,
        unit: null,
        isDel: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        remark: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(sel) {
      let selection=sel.filter(d=>d.deptId);
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加物资类型";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getAssetsType(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改物资类型";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateAssetsType(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addAssetsType(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除物资类型编号为"' + ids + '"的数据项？').then(function () {
        return delAssetsType(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => { });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('base/assetsType/export', {
        ...this.queryParams
      }, `assetsType_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
